//
//  SBSDKPDFRendererPageSize.swift
//  Pods-Runner
//
//  Created by Zhenya Knizhnik on 02.09.19.
//

import Foundation
import ScanbotSDK

extension SBSDKPDFRendererPageSize {
    init(string: String) {
        switch string {
        case "LETTER": self = .letter
        case "LEGAL": self = .legal
        case "A3": self = .A3
        case "A4": self = .A4
        case "A5": self = .A5
        case "B4": self = .B4
        case "B5": self = .B5
        case "EXECUTIVE": self = .executive
        case "US4x6": self = .us4x6
        case "US4x8": self = .us4x8
        case "US5x7": self = .us5x7
        case "COMM10": self = .COMM10
        case "CUSTOM": self = .custom
        default: self = .custom
        }
    }
    
    init?(from dictionary: [String: Any]) {
        guard let options = dictionary["options"] as? [String: Any],
            let string = options["pageSize"] as? String else {
            return nil
        }
        self.init(string: string)
    }
}
