//
//  GenericDocumentRecognizerPresenter.swift
//  scanbot_sdk
//
//  Created by Sarbjyot Chahal on 12.01.22.
//

import Foundation
import ScanbotSDK
import Flutter

class GenericDocumentRecognizerPresenter: NSObject {
    private var resultHandler: FlutterResult?
    
    func present(on presenter: UIViewController,
                 with configuration: SBSDKUIGenericDocumentRecognizerConfiguration,
                 result: @escaping FlutterResult) {
        self.resultHandler = result
        let controller = SBSDKUIGenericDocumentRecognizerViewController.createNew(with: configuration,
                                                                                  andDelegate: self)
        
        controller.modalPresentationStyle = .fullScreen
        presenter.present(controller, animated: true, completion: nil)
    }
}

extension GenericDocumentRecognizerPresenter: SBSDKUIGenericDocumentRecognizerViewControllerDelegate {
    func genericDocumentRecognizerViewController(_ viewController: SBSDKUIGenericDocumentRecognizerViewController,
                                                 didFinishWith documents: [SBSDKGenericDocument]) {
        
      
        do {
            var documentsJson = [[String: Any]]()
            for document in documents {
                documentsJson.append(document.encodedDictionary)
            }
            
            let result = [
                "documents": documentsJson
            ]
            self.resultHandler?(result.encodedString)
        } catch(let error) {
            print(error.localizedDescription)
            self.resultHandler = nil
        }
    }
    
    func scanningViewControllerDidCancel(_ viewController: SBSDKUIDocumentScannerViewController) {
        self.resultHandler?("CANCELED")
        self.resultHandler = nil
    }
}
