import 'package:json_annotation/json_annotation.dart';

import 'json/common.dart';
import 'json/common_platform.dart';

part 'render_pdf_data.g.dart';

@JsonSerializable(
    includeIfNull: false, explicitToJson: true, createFactory: false)
class PdfRenderingOptions {
  /// The direction of the page in the PDF document.
  final PageDirection pageDirection;

  /// The size of the page in the PDF document.
  final PageSize pageSize;

  /// The PDF document attributes.
  final PdfAttributes pdfAttributes;

  const PdfRenderingOptions(
      {this.pageSize = PageSize.CUSTOM,
      this.pageDirection = PageDirection.AUTO,
      this.pdfAttributes = const PdfAttributes(
        creator: "",
        author: "",
        title: "",
        subject: "",
        keywords: "",
      )});

  Map<String, dynamic> toJson() => _$PdfRenderingOptionsToJson(this);
}
